=== debian/changelog ===
lyx (2.4.0~RC3-1build4) noble; urgency=medium

  * No-change rebuild against libqt5core5t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Apr 2024 01:49:53 +0100

lyx (2.4.0~RC3-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:09:28 +0000

lyx (2.4.0~RC3-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:50:01 +0000

lyx (2.4.0~RC3-1build1) noble; urgency=medium

  * No-change rebuild for libmagic t64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 13:42:48 +0100

lyx (2.4.0~RC3-1) unstable; urgency=medium

  * New upstream version 2.4.0~RC3

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 11 Feb 2024 23:41:17 +0100

lyx (2.4.0~RC2-1) unstable; urgency=medium

  [ Pavel Sanda ]
  * Reword package description

  [ Dr. Tobias Quathamer ]
  * New upstream version 2.4.0~RC2

 -- Dr. Tobias Quathamer <toddy@debian.org>  Thu, 08 Feb 2024 22:22:05 +0100

lyx (2.4.0~RC1-2) unstable; urgency=medium

  [ Pavel Sanda ]
  * libtiff-tools -> Recommends.
    2.4 knows workarounds for the (debian default)
    bans on postscript conversion (see e.g. #975678).
    But libtiff-tools & poppler-utils are needed.
  * New DocBook 5 dependencies.
    - sgml 4 was dropped
    - DocBook 5 (XML) is supported
    - conversion to ePub is supported

  [ Dr. Tobias Quathamer ]
  * Add 'Forwarded:' information to d/patches
  * Reformat with wrap-and-sort -at
  * Upgrade xsltproc and docbook-xsl from Suggests to Recommends.
    This is based on a suggestion by Pavel Sanda to support
    export to ePub format.

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 20 Jan 2024 21:45:28 +0100

lyx (2.4.0~RC1-1) unstable; urgency=medium

  * New upstream version 2.4.0~RC1
    - Refresh patches
    - Handle renaming of README file for BaKoMa Fonts
    - Add license for lib/org.lyx.LyX.metainfo.xml to d/copyright
    - Add two lintian overrides for false positive errors
  * Update d/copyright

 -- Dr. Tobias Quathamer <toddy@debian.org>  Wed, 17 Jan 2024 18:40:41 +0100
